diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/rfbproto.c vnc_unixsrc/vncviewer/rfbproto.c
--- vnc_unixsrc.orig/vncviewer/rfbproto.c	2008-09-05 19:51:24.000000000 -0400
+++ vnc_unixsrc/vncviewer/rfbproto.c	2010-04-17 22:34:38.000000000 -0400
@@ -942,281 +2294,1025 @@
 Bool
 SendClientCutText(char *str, int len)
 {
-  rfbClientCutTextMsg cct;
+	rfbClientCutTextMsg cct;
+
+	if (serverCutText) {
+		free(serverCutText);
+	}
+	serverCutText = NULL;
+
+	if (appData.fileActive) {
+		if (!dyn || time(NULL) < last_filexfer + delay_filexfer) {
+			/* ultravnc java viewer lets this one through. */
+			return True;
+		}
+	}
+
+	if (appData.viewOnly) {
+		return True;
+	}
 
-  if (serverCutText)
-    free(serverCutText);
-  serverCutText = NULL;
-
-  cct.type = rfbClientCutText;
-  cct.length = Swap32IfLE(len);
-  return  (WriteExact(rfbsock, (char *)&cct, sz_rfbClientCutTextMsg) &&
-	   WriteExact(rfbsock, str, len));
+	cct.type = rfbClientCutText;
+	cct.length = Swap32IfLE((unsigned int) len);
+	currentMsg = rfbClientCutText;
+	return  (WriteExact(rfbsock, (char *)&cct, sz_rfbClientCutTextMsg) &&
+	    WriteExact(rfbsock, str, len));
 }
 
+static int ultra_scale = 0;
 
-/*
- * HandleRFBServerMessage.
- */
+Bool
+SendServerScale(int nfac)
+{
+	rfbSetScaleMsg ssc;
+	if (nfac < 0 || nfac > 100) {
+		return True;
+	}
+
+	ultra_scale = nfac;
+	ssc.type = rfbSetScale;
+	ssc.scale = nfac;
+	currentMsg = rfbSetScale;
+	return WriteExact(rfbsock, (char *)&ssc, sz_rfbSetScaleMsg);
+}
 
 Bool
-HandleRFBServerMessage()
+SendServerInput(Bool enabled)
 {
-  rfbServerToClientMsg msg;
+	rfbSetServerInputMsg sim;
 
-  if (!ReadFromRFBServer((char *)&msg, 1))
-    return False;
+	sim.type = rfbSetServerInput;
+	sim.status = enabled;
+	currentMsg = rfbSetServerInput;
+	return WriteExact(rfbsock, (char *)&sim, sz_rfbSetServerInputMsg);
+}
 
-  switch (msg.type) {
+Bool
+SendSingleWindow(int x, int y)
+{
+	static int w_old = -1, h_old = -1;
+	rfbSetSWMsg sw;
 
-  case rfbSetColourMapEntries:
-  {
-    int i;
-    CARD16 rgb[3];
-    XColor xc;
+	fprintf(stderr, "SendSingleWindow: %d %d\n", x, y);
 
-    if (!ReadFromRFBServer(((char *)&msg) + 1,
-			   sz_rfbSetColourMapEntriesMsg - 1))
-      return False;
+	if (x == -1 && y == -1)  {
+		sw.type = rfbSetSW;
+		sw.x = Swap16IfLE(1);
+		sw.y = Swap16IfLE(1);
+		if (w_old > 0) {
+			si.framebufferWidth  = w_old;
+			si.framebufferHeight = h_old;
+			ReDoDesktop();
+		}
+		w_old = h_old = -1;
+	} else {
+		sw.type = rfbSetSW;
+		sw.x = Swap16IfLE(x);
+		sw.y = Swap16IfLE(y);
+		w_old = si.framebufferWidth;
+		h_old = si.framebufferHeight;
+		
+	}
+	sw.status = True;
+	currentMsg = rfbSetSW;
+	return WriteExact(rfbsock, (char *)&sw, sz_rfbSetSWMsg);
+}
 
-    msg.scme.firstColour = Swap16IfLE(msg.scme.firstColour);
-    msg.scme.nColours = Swap16IfLE(msg.scme.nColours);
+Bool
+SendTextChat(char *str)
+{
+	static int db = -1;
+	rfbTextChatMsg chat;
 
-    for (i = 0; i < msg.scme.nColours; i++) {
-      if (!ReadFromRFBServer((char *)rgb, 6))
-	return False;
-      xc.pixel = msg.scme.firstColour + i;
-      xc.red = Swap16IfLE(rgb[0]);
-      xc.green = Swap16IfLE(rgb[1]);
-      xc.blue = Swap16IfLE(rgb[2]);
-      xc.flags = DoRed|DoGreen|DoBlue;
-      XStoreColor(dpy, cmap, &xc);
-    }
+	if (db < 0) {
+		if (getenv("SSVNC_DEBUG_CHAT")) {
+			db = 1;
+		} else {
+			db = 0;
+		}
+	}
+	if (!appData.chatActive) {
+		SendTextChatOpen();
+		appData.chatActive = True;
+	}
 
-    break;
-  }
+	chat.type = rfbTextChat;
+	chat.pad1 = 0;
+	chat.pad2 = 0;
+	chat.length = (unsigned int) strlen(str);
+	if (db) fprintf(stderr, "SendTextChat: %d '%s'\n", (int) chat.length, str);
+	chat.length = Swap32IfLE(chat.length);
+	if (!WriteExact(rfbsock, (char *)&chat, sz_rfbTextChatMsg)) {
+		return False;
+	}
+	currentMsg = rfbTextChat;
+	return WriteExact(rfbsock, str, strlen(str));
+}
 
-  case rfbFramebufferUpdate:
-  {
-    rfbFramebufferUpdateRectHeader rect;
-    int linesToRead;
-    int bytesPerLine;
-    int i;
-    int usecs;
+extern void raiseme(int force);
 
-    if (!ReadFromRFBServer(((char *)&msg.fu) + 1,
-			   sz_rfbFramebufferUpdateMsg - 1))
-      return False;
+Bool
+SendTextChatOpen(void)
+{
+	rfbTextChatMsg chat;
 
-    msg.fu.nRects = Swap16IfLE(msg.fu.nRects);
+	raiseme(0);
+	chat.type = rfbTextChat;
+	chat.pad1 = 0;
+	chat.pad2 = 0;
+	chat.length = Swap32IfLE(rfbTextChatOpen);
+	return WriteExact(rfbsock, (char *)&chat, sz_rfbTextChatMsg);
+}
 
-    for (i = 0; i < msg.fu.nRects; i++) {
-      if (!ReadFromRFBServer((char *)&rect, sz_rfbFramebufferUpdateRectHeader))
-	return False;
+Bool
+SendTextChatClose(void)
+{
+	rfbTextChatMsg chat;
+	chat.type = rfbTextChat;
+	chat.pad1 = 0;
+	chat.pad2 = 0;
+	chat.length = Swap32IfLE(rfbTextChatClose);
+	appData.chatActive = False;
+	return WriteExact(rfbsock, (char *)&chat, sz_rfbTextChatMsg);
+}
 
-      rect.encoding = Swap32IfLE(rect.encoding);
-      if (rect.encoding == rfbEncodingLastRect)
-	break;
+Bool
+SendTextChatFinished(void)
+{
+	rfbTextChatMsg chat;
+	chat.type = rfbTextChat;
+	chat.pad1 = 0;
+	chat.pad2 = 0;
+	chat.length = Swap32IfLE(rfbTextChatFinished);
+	appData.chatActive = False;
+	return WriteExact(rfbsock, (char *)&chat, sz_rfbTextChatMsg);
+}
+
+extern int do_format_change;
+extern int do_cursor_change;
+extern double do_fb_update;
+extern void cutover_format_change(void);
+
+double dtime(double *t_old) {
+        /* 
+         * usage: call with 0.0 to initialize, subsequent calls give
+         * the time difference since last call.
+         */
+        double t_now, dt;
+        struct timeval now;
+
+        gettimeofday(&now, NULL);
+        t_now = now.tv_sec + ( (double) now.tv_usec/1000000. );
+        if (*t_old == 0.0) {
+                *t_old = t_now;
+                return t_now;
+        }
+        dt = t_now - *t_old;
+        *t_old = t_now;
+        return(dt);
+}
+
+/* common dtime() activities: */
+double dtime0(double *t_old) {
+        *t_old = 0.0;
+        return dtime(t_old);
+}
+
+double dnow(void) {
+        double t;
+        return dtime0(&t);
+}
+
+static char fxfer[65536];
+
+Bool HandleFileXfer(void) {
+	unsigned char hdr[12];
+	unsigned int len;
+
+        int rfbDirContentRequest = 1;
+        int rfbDirPacket = 2; /* Full directory name or full file name. */
+        int rfbFileTransferRequest = 3;
+        int rfbFileHeader = 4;
+        int rfbFilePacket = 5; /* One slice of the file */
+        int rfbEndOfFile = 6;
+        int rfbAbortFileTransfer = 7;
+        int rfbFileTransferOffer = 8;
+        int rfbFileAcceptHeader = 9; /* The server accepts or rejects the file */
+        int rfbCommand = 10;
+        int rfbCommandReturn = 11;
+        int rfbFileChecksums = 12;
+
+        int rfbRDirContent = 1; /* Request a Server Directory contents */
+        int rfbRDrivesList = 2; /* Request the server's drives list */
+
+        int rfbADirectory = 1; /* Reception of a directory name */
+        int rfbAFile = 2; /* Reception of a file name  */
+        int rfbADrivesList = 3; /* Reception of a list of drives */
+        int rfbADirCreate = 4; /* Response to a create dir command  */
+        int rfbADirDelete = 5; /* Response to a delete dir command  */
+        int rfbAFileCreate = 6; /* Response to a create file command  */
+        int rfbAFileDelete = 7; /* Response to a delete file command */
+
+        int rfbCDirCreate = 1; /* Request the server to create the given directory */
+        int rfbCDirDelete = 2; /* Request the server to delete the given directory */
+        int rfbCFileCreate = 3; /* Request the server to create the given file */
+        int rfbCFileDelete = 4; /* Request the server to delete the given file */
+
+        int rfbRErrorUnknownCmd = 1; /* Unknown FileTransfer command. */
+#define rfbRErrorCmd 0xFFFFFFFF
+
+	static int db = -1;
+	static int guess_x11vnc = 0;
+
+#if 0
+	if (filexfer_sock < 0) {
+		return True;
+	}
+	/* instead, we read and discard the ft msg data. */
+#endif
+
+/*fprintf(stderr, "In  HandleFileXfer\n"); */
 
-      rect.r.x = Swap16IfLE(rect.r.x);
-      rect.r.y = Swap16IfLE(rect.r.y);
-      rect.r.w = Swap16IfLE(rect.r.w);
-      rect.r.h = Swap16IfLE(rect.r.h);
-
-      if (rect.encoding == rfbEncodingXCursor ||
-	  rect.encoding == rfbEncodingRichCursor) {
-	if (!HandleCursorShape(rect.r.x, rect.r.y, rect.r.w, rect.r.h,
-			      rect.encoding)) {
-	  return False;
+	if (db < 0) {
+		if (getenv("DEBUG_HandleFileXfer")) {
+			db = 1;
+		} else {
+			db = 0;
+		}
 	}
-	continue;
-      }
 
-      if (rect.encoding == rfbEncodingPointerPos) {
-	if (!HandleCursorPos(rect.r.x, rect.r.y)) {
-	  return False;
+	last_filexfer = time(NULL);
+	/*fprintf(stderr, "last_filexfer-1: %d\n", last_filexfer); */
+
+	/* load first byte to send to Java be the FT msg number: */
+	hdr[0] = rfbFileTransfer;
+
+	/* this is to avoid XtAppProcessEvent() calls induce by our ReadFromRFBServer calls below: */
+	skip_XtUpdateAll = 1;
+	if (!ReadFromRFBServer(&hdr[1], 11)) {
+		skip_XtUpdateAll = 0;
+		return False;
+	}
+	if (filexfer_sock >= 0) {
+		write(filexfer_sock, hdr, 12);
+	} else {
+		fprintf(stderr, "filexfer_sock closed, discarding 12 bytes\n");
+	}
+	if (db) fprintf(stderr, "\n");
+	if (db) fprintf(stderr, "Got rfbFileTransfer hdr\n");
+	if (db > 1) write(2, hdr, 12);
+
+	if (db) {
+		int i;
+		fprintf(stderr, "HFX HDR:");
+		for (i=0; i < 12; i++) {
+			fprintf(stderr, " %d", (int) hdr[i]);
+		}
+		fprintf(stderr, "\n");
 	}
-	continue;
-      }
 
-      if ((rect.r.x + rect.r.w > si.framebufferWidth) ||
-	  (rect.r.y + rect.r.h > si.framebufferHeight))
-	{
-	  fprintf(stderr,"Rect too large: %dx%d at (%d, %d)\n",
-		  rect.r.w, rect.r.h, rect.r.x, rect.r.y);
-	  return False;
+	if (hdr[1] == rfbEndOfFile) {
+		goto read_no_more;
+	} else if (hdr[1] == rfbAbortFileTransfer) {
+		goto read_no_more;
 	}
 
-      if (rect.r.h * rect.r.w == 0) {
-	fprintf(stderr,"Zero size rect - ignoring\n");
-	continue;
-      }
+	if (hdr[1] == rfbDirPacket && hdr[3] == rfbADirectory) {
+		
+	}
+
+	len = (hdr[8] << 24) | (hdr[9] << 16) | (hdr[10] << 8) | hdr[11];
+	if (db) fprintf(stderr, "Got rfbFileTransfer: len1 %u\n", len);
+	if (len > 0) {
+		if (!ReadFromRFBServer(fxfer, len)) {
+			skip_XtUpdateAll = 0;
+			return False;
+		}
+		if (db > 1) write(2, fxfer, len);
+		if (len >= 12 && hdr[1] == rfbDirPacket) {
+			/* try to guess if x11vnc or not... */
+			if (db) {
+				int i;
+				fprintf(stderr, "HFX DIR PKT (attr, timeL, timeH):");
+				for (i=0; i < 12; i++) {
+					fprintf(stderr, " %d", (unsigned char) fxfer[i]);
+				}
+				fprintf(stderr, "\n");
+			}
+			if (hdr[2] == 1) {
+				int dattr  = (unsigned char) fxfer[0];
+				int timeL1 = (unsigned char) fxfer[4];
+				int timeL2 = (unsigned char) fxfer[5];
+				int timeL3 = (unsigned char) fxfer[6];
+				int timeL4 = (unsigned char) fxfer[7];
+				int timeH1 = (unsigned char) fxfer[8];
+				int timeH2 = (unsigned char) fxfer[9];
+				int timeH3 = (unsigned char) fxfer[10];
+				int timeH4 = (unsigned char) fxfer[11];
+				if (dattr != 0) {
+					if (timeH1 == 0 && timeH2 == 0 && timeH3 == 0 && timeH4 == 0) {
+						if ((timeL1 != 0 || timeL2 != 0) && timeL3 != 0 && timeL4 != 0) {
+							if (!guess_x11vnc) fprintf(stderr, "guessed x11vnc server\n");
+							guess_x11vnc = 1;
+						}
+					}
+				}
+			}
+		}
+		if (db && 0) fprintf(stderr, "\n");
+		if (filexfer_sock >= 0) {
+			write(filexfer_sock, fxfer, len);
+		} else {
+			fprintf(stderr, "filexfer_sock closed, discarding %d bytes\n", len);
+		}
+	}
+
+	len = (hdr[4] << 24) | (hdr[5] << 16) | (hdr[6] << 8) | hdr[7];
+	if (db) fprintf(stderr, "Got rfbFileTransfer: len2 %u\n", len);
+
+#if 0
+	if (hdr[1] == rfbFileHeader && len != rfbRErrorCmd)
+#else
+	/* the extra 4 bytes get send on rfbRErrorCmd as well. */
+	if (hdr[1] == rfbFileHeader) {
+#endif
+		int is_err = 0;
+		if (len == rfbRErrorCmd) {
+			is_err = 1;
+		}
+		if (db) fprintf(stderr, "Got rfbFileTransfer: rfbFileHeader\n");
+		if (is_err && guess_x11vnc) {
+			fprintf(stderr, "rfbRErrorCmd x11vnc skip read 4 bytes.\n");
+			goto read_no_more;
+		}
+		len = 4;
+		if (!ReadFromRFBServer(fxfer, len)) {
+			skip_XtUpdateAll = 0;
+			return False;
+		}
+		if (db > 1) write(2, fxfer, len);
+		if (db && 0) fprintf(stderr, "\n");
+		if (is_err) {
+			fprintf(stderr, "rfbRErrorCmd skip write 4 bytes.\n");
+			goto read_no_more;
+		}
+		if (filexfer_sock >= 0) {
+			write(filexfer_sock, fxfer, len);
+		} else {
+			fprintf(stderr, "filexfer_sock closed, discarding %d bytes\n", len);
+		}
+	}
 
-      /* If RichCursor encoding is used, we should prevent collisions
-	 between framebuffer updates and cursor drawing operations. */
-      SoftCursorLockArea(rect.r.x, rect.r.y, rect.r.w, rect.r.h);
+	read_no_more:
 
-      switch (rect.encoding) {
+	if (filexfer_sock < 0) {
+		int stop = 0;
+		static time_t last_stop = 0;
+#if 0
+		/* this isn't working */
+		if (hdr[1] == rfbFilePacket || hdr[1] == rfbFileHeader) {
+			fprintf(stderr, "filexfer_sock closed, trying to abort receive\n");
+			stop = 1;
+		}
+#endif
+		if (stop && time(NULL) > last_stop+1) {
+			unsigned char rpl[12];
+			int k;
+			rpl[0] = rfbFileTransfer;
+			rpl[1] = rfbAbortFileTransfer;
+			for (k=2; k < 12; k++) {
+				rpl[k] = 0;
+			}
+			WriteExact(rfbsock, rpl, 12);
+			last_stop = time(NULL);
+		}
+	}
 
-      case rfbEncodingRaw:
+	if (db) fprintf(stderr, "Got rfbFileTransfer done.\n");
+	skip_XtUpdateAll = 0;
 
-	bytesPerLine = rect.r.w * myFormat.bitsPerPixel / 8;
-	linesToRead = BUFFER_SIZE / bytesPerLine;
+	if (db) fprintf(stderr, "CFX: B\n");
+	CheckFileXfer();
+/*fprintf(stderr, "Out HandleFileXfer\n"); */
+	return True;
+}
 
-	while (rect.r.h > 0) {
-	  if (linesToRead > rect.r.h)
-	    linesToRead = rect.r.h;
+/*
+ * HandleRFBServerMessage.
+ */
 
-	  if (!ReadFromRFBServer(buffer,bytesPerLine * linesToRead))
-	    return False;
 
-	  CopyDataToScreen(buffer, rect.r.x, rect.r.y, rect.r.w,
-			   linesToRead);
+Bool
+HandleRFBServerMessage()
+{
+	static int db = -1;
+	rfbServerToClientMsg msg;
 
-	  rect.r.h -= linesToRead;
-	  rect.r.y += linesToRead;
+	if (db < 0) {
+		if (getenv("DEBUG_RFB_SMSG")) {
+			db = 1;
+		} else {
+			db = 0;
+		}
+	}
 
+	if (!ReadFromRFBServer((char *)&msg, 1)) {
+		return False;
 	}
-	break;
+	if (appData.ultraDSM) {
+		if (!ReadFromRFBServer((char *)&msg, 1)) {
+			return False;
+		}
+	}
+
+/*fprintf(stderr, "msg.type: %d\n", msg.type); */
 
-      case rfbEncodingCopyRect:
-      {
-	rfbCopyRect cr;
-
-	if (!ReadFromRFBServer((char *)&cr, sz_rfbCopyRect))
-	  return False;
-
-	cr.srcX = Swap16IfLE(cr.srcX);
-	cr.srcY = Swap16IfLE(cr.srcY);
-
-	/* If RichCursor encoding is used, we should extend our
-	   "cursor lock area" (previously set to destination
-	   rectangle) to the source rectangle as well. */
-	SoftCursorLockArea(cr.srcX, cr.srcY, rect.r.w, rect.r.h);
-
-	if (appData.copyRectDelay != 0) {
-	  XFillRectangle(dpy, desktopWin, srcGC, cr.srcX, cr.srcY,
-			 rect.r.w, rect.r.h);
-	  XFillRectangle(dpy, desktopWin, dstGC, rect.r.x, rect.r.y,
-			 rect.r.w, rect.r.h);
-	  XSync(dpy,False);
-	  usleep(appData.copyRectDelay * 1000);
-	  XFillRectangle(dpy, desktopWin, dstGC, rect.r.x, rect.r.y,
-			 rect.r.w, rect.r.h);
-	  XFillRectangle(dpy, desktopWin, srcGC, cr.srcX, cr.srcY,
-			 rect.r.w, rect.r.h);
+	if (msg.type == rfbFileTransfer) {
+		return HandleFileXfer();
 	}
 
-	XCopyArea(dpy, desktopWin, desktopWin, gc, cr.srcX, cr.srcY,
-		  rect.r.w, rect.r.h, rect.r.x, rect.r.y);
+    switch (msg.type) {
 
-	break;
-      }
+    case rfbSetColourMapEntries:
+    {
+	int i;
+	CARD16 rgb[3];
+	XColor xc;
 
-      case rfbEncodingRRE:
-      {
-	switch (myFormat.bitsPerPixel) {
-	case 8:
-	  if (!HandleRRE8(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 16:
-	  if (!HandleRRE16(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 32:
-	  if (!HandleRRE32(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
+	if (!ReadFromRFBServer(((char *)&msg) + 1, sz_rfbSetColourMapEntriesMsg - 1)) {
+		return False;
 	}
-	break;
-      }
 
-      case rfbEncodingCoRRE:
-      {
-	switch (myFormat.bitsPerPixel) {
-	case 8:
-	  if (!HandleCoRRE8(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 16:
-	  if (!HandleCoRRE16(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 32:
-	  if (!HandleCoRRE32(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
+	msg.scme.firstColour = Swap16IfLE(msg.scme.firstColour);
+	msg.scme.nColours = Swap16IfLE(msg.scme.nColours);
+
+	for (i = 0; i < msg.scme.nColours; i++) {
+		if (!ReadFromRFBServer((char *)rgb, 6)) {
+			return False;
+		}
+		xc.pixel = msg.scme.firstColour + i;
+		xc.red = Swap16IfLE(rgb[0]);
+		xc.green = Swap16IfLE(rgb[1]);
+		xc.blue = Swap16IfLE(rgb[2]);
+		if (appData.useGreyScale) {
+			int ave = (xc.red + xc.green + xc.blue)/3;
+			xc.red   = ave;
+			xc.green = ave;
+			xc.blue  = ave;
+		}
+		xc.flags = DoRed|DoGreen|DoBlue;
+		XStoreColor(dpy, cmap, &xc);
 	}
+
 	break;
-      }
+    }
+
+    case rfbFramebufferUpdate:
+    {
+	rfbFramebufferUpdateRectHeader rect;
+	int linesToRead;
+	int bytesPerLine;
+	int i;
+
+	int area_copyrect = 0;
+	int area_tight = 0;
+	int area_zrle = 0;
+	int area_raw = 0;
+	static int rdb = -1;
+	static int delay_sync = -1;
+	static int delay_sync_env = -1;
+	int try_delay_sync = 0;
+	int cnt_pseudo = 0;
+	int cnt_image  = 0;
+
+	int skip_incFBU = 0;
+
+	if (db) fprintf(stderr, "FBU-0:    %.6f\n", dnow());
+	if (rdb < 0) {
+		if (getenv("SSVNC_DEBUG_RECTS")) {
+			rdb = atoi(getenv("SSVNC_DEBUG_RECTS"));
+		} else {
+			rdb = 0;
+		}
+	}
+	if (delay_sync < 0) {
+		if (getenv("SSVNC_DELAY_SYNC")) {
+			delay_sync = atoi(getenv("SSVNC_DELAY_SYNC"));
+			delay_sync_env = delay_sync;
+		} else {
+			delay_sync = 0;
+		}
+	}
+
+	sent_FBU = -1;
 
-      case rfbEncodingHextile:
-      {
-	switch (myFormat.bitsPerPixel) {
-	case 8:
-	  if (!HandleHextile8(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 16:
-	  if (!HandleHextile16(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 32:
-	  if (!HandleHextile32(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
+	if (appData.pipelineUpdates) {
+		/* turbovnc speed idea */
+		XEvent ev;
+		memset(&ev, 0, sizeof(ev));
+		ev.xclient.type = ClientMessage;
+		ev.xclient.window = XtWindow(desktop);
+		ev.xclient.message_type = XA_INTEGER;
+		ev.xclient.format = 8;
+		strcpy(ev.xclient.data.b, "SendRFBUpdate");
+		XSendEvent(dpy, XtWindow(desktop), False, 0, &ev);
 	}
-	break;
-      }
 
-      case rfbEncodingZlib:
-      {
-	switch (myFormat.bitsPerPixel) {
-	case 8:
-	  if (!HandleZlib8(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 16:
-	  if (!HandleZlib16(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 32:
-	  if (!HandleZlib32(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
+	if (!ReadFromRFBServer(((char *)&msg.fu) + 1, sz_rfbFramebufferUpdateMsg - 1)) {
+		return False;
 	}
-	break;
-     }
 
-      case rfbEncodingTight:
-      {
-	switch (myFormat.bitsPerPixel) {
-	case 8:
-	  if (!HandleTight8(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 16:
-	  if (!HandleTight16(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
-	case 32:
-	  if (!HandleTight32(rect.r.x,rect.r.y,rect.r.w,rect.r.h))
-	    return False;
-	  break;
+	msg.fu.nRects = Swap16IfLE(msg.fu.nRects);
+
+	if (rdb) fprintf(stderr, "Begin rect loop %d\n", msg.fu.nRects);
+
+	if (delay_sync) {
+		try_delay_sync = 1;
+	} else {
+		if (delay_sync_env != -1 && delay_sync_env == 0) {
+			;
+		} else if (appData.yCrop > 0) {
+			;
+		} else if (scale_factor_x > 0.0 && scale_factor_x != 1.0) {
+			;
+		} else if (scale_factor_y > 0.0 && scale_factor_y != 1.0) {
+			;
+		} else {
+			static int msg = 0;
+			/* fullScreen? */
+			/* useXserverBackingStore? */
+			/* useX11Cursor & etc? */
+			/* scrollbars? */
+			if (!msg) {
+				fprintf(stderr, "enabling 'delay_sync' mode for faster local drawing,\ndisable via env SSVNC_DELAY_SYNC=0 if there are painting errors.\n"); 
+				msg = 1;
+			}
+			try_delay_sync = 1;
+		}
+	}
+	if (try_delay_sync) {
+		skip_maybe_sync = 1;
+	}
+#define STOP_DELAY_SYNC \
+	if (try_delay_sync) { \
+		if (cnt_image && skip_maybe_sync) { \
+			XSync(dpy, False); \
+		} \
+		try_delay_sync = 0; \
+		skip_maybe_sync = 0; \
 	}
-	break;
-      }
 
-      default:
-	fprintf(stderr,"Unknown rect encoding %d\n",
-		(int)rect.encoding);
-	return False;
-      }
+	for (i = 0; i < msg.fu.nRects; i++) {
+		if (!ReadFromRFBServer((char *)&rect, sz_rfbFramebufferUpdateRectHeader)) {
+			return False;
+		}
+
+		rect.encoding = Swap32IfLE(rect.encoding);
+		if (rect.encoding == rfbEncodingLastRect) {
+			break;
+		}
+
+		rect.r.x = Swap16IfLE(rect.r.x);
+		rect.r.y = Swap16IfLE(rect.r.y);
+		rect.r.w = Swap16IfLE(rect.r.w);
+		rect.r.h = Swap16IfLE(rect.r.h);
+
+		if (rdb > 1) fprintf(stderr, "nRects: %d  i=%d enc: %d   %dx%d+%d+%d\n", msg.fu.nRects, i, (int) rect.encoding, rect.r.w, rect.r.h, rect.r.x, rect.r.y); 
+			
+		if (rect.encoding == rfbEncodingXCursor || rect.encoding == rfbEncodingRichCursor) {
+			cnt_pseudo++;
+			STOP_DELAY_SYNC	
+			
+			if (db) fprintf(stderr, "FBU-Cur1  %.6f\n", dnow());
+			if (!HandleCursorShape(rect.r.x, rect.r.y, rect.r.w, rect.r.h, rect.encoding)) {
+				return False;
+			}
+			if (db) fprintf(stderr, "FBU-Cur2  %.6f\n", dnow());
+			continue;
+		}
+
+		if (rect.encoding == rfbEncodingPointerPos) {
+			cnt_pseudo++;
+			STOP_DELAY_SYNC	
+			if (db) fprintf(stderr, "FBU-Pos1  %.6f\n", dnow());
+			if (0) fprintf(stderr, "CursorPos: %d %d / %d %d\n", rect.r.x, rect.r.y, rect.r.w, rect.r.h);
+			if (ultra_scale > 0) {
+				int f = ultra_scale;
+				if (!HandleCursorPos(rect.r.x/f, rect.r.y/f)) {
+					return False;
+				}
+			} else {
+				if (!HandleCursorPos(rect.r.x, rect.r.y)) {
+					return False;
+				}
+			}
+			if (db) fprintf(stderr, "FBU-Pos2  %.6f\n", dnow());
+			continue;
+		}
+		if (rect.encoding == rfbEncodingNewFBSize) {
+			cnt_pseudo++;
+			STOP_DELAY_SYNC	
+			if (appData.chatOnly) {
+				continue;
+			}
+			fprintf(stderr,"New Size: %dx%d at (%d, %d)\n", rect.r.w, rect.r.h, rect.r.x, rect.r.y);
+			si.framebufferWidth = rect.r.w;
+			si.framebufferHeight = rect.r.h;
+			/*fprintf(stderr, "si: %d %d\n", si.framebufferWidth, si.framebufferHeight); */
+			ReDoDesktop();
+			continue;
+		}
+		if (rdb) fprintf(stderr,"Rect: %dx%d at (%d, %d)\n", rect.r.w, rect.r.h, rect.r.x, rect.r.y);
+		cnt_image++;
+
+		if (appData.ultraDSM) {
+			/*
+			 * What a huge mess the UltraVNC DSM plugin is!!!
+			 * We read and ignore their little "this much data" hint...
+			 */
+			switch (rect.encoding)
+			{
+			case rfbEncodingRaw:
+			case rfbEncodingRRE:
+			case rfbEncodingCoRRE:
+			case rfbEncodingHextile:
+			/*case rfbEncodingUltra: */
+/*			case rfbEncodingZlib: */
+			/*case rfbEncodingXOR_Zlib: */
+			/*case rfbEncodingXORMultiColor_Zlib: */
+			/*case rfbEncodingXORMonoColor_Zlib: */
+			/*case rfbEncodingSolidColor: */
+			case rfbEncodingTight:
+			case rfbEncodingZlibHex:
+			case rfbEncodingZRLE:
+			case rfbEncodingZYWRLE:
+			    {
+				CARD32 discard;
+				ReadFromRFBServer((char *)&discard, sizeof(CARD32));
+			    }
+			    break;
+			}
+		}
+
+		if ((rect.r.x + rect.r.w > si.framebufferWidth) ||
+		    (rect.r.y + rect.r.h > si.framebufferHeight)) {
+			if (!appData.chatOnly) {
+				fprintf(stderr,"Rect too large: %dx%d at (%d, %d) encoding=%d\n",
+				rect.r.w, rect.r.h, rect.r.x, rect.r.y, (int) rect.encoding);
+				return False;
+			}
+		}
+
+		if (rect.r.h * rect.r.w == 0) {
+			fprintf(stderr,"*** Warning *** Zero size rect: %dx%d+%d+%d  encoding=%d\n",
+			    rect.r.w, rect.r.h, rect.r.x, rect.r.y, (int) rect.encoding);
+			if (0) continue;
+		}
+
+		/* If RichCursor encoding is used, we should prevent collisions
+		   between framebuffer updates and cursor drawing operations. */
+		if (db) fprintf(stderr, "FBU-SCL1  %.6f\n", dnow());
+
+		SoftCursorLockArea(rect.r.x, rect.r.y, rect.r.w, rect.r.h);
+
+		if (db) fprintf(stderr, "FBU-SCL2  %.6f\n", dnow());
+
+
+		switch (rect.encoding) {
+
+		case rfbEncodingRaw:
+
+			bytesPerLine = rect.r.w * myFormat.bitsPerPixel / 8;
+			linesToRead = BUFFER_SIZE / bytesPerLine;
+
+			if (db) fprintf(stderr, "Raw:     %dx%d+%d+%d\n", rect.r.w, rect.r.h, rect.r.x, rect.r.y);
+			area_raw += rect.r.w * rect.r.h;
+
+			while (rect.r.h > 0) {
+				if (linesToRead > rect.r.h) {
+					linesToRead = rect.r.h;
+				}
+
+				if (!ReadFromRFBServer(buffer,bytesPerLine * linesToRead)) {
+					return False;
+				}
+
+				CopyDataToScreen(buffer, rect.r.x, rect.r.y, rect.r.w, linesToRead);
+
+				rect.r.h -= linesToRead;
+				rect.r.y += linesToRead;
+			}
+			break;
+
+		case rfbEncodingCopyRect:
+		{
+			rfbCopyRect cr;
+
+			STOP_DELAY_SYNC	
+			XSync(dpy, False);
+
+			if (!ReadFromRFBServer((char *)&cr, sz_rfbCopyRect)) {
+				return False;
+			}
+			if (appData.chatOnly) {
+				break;
+			}
+
+			cr.srcX = Swap16IfLE(cr.srcX);
+			cr.srcY = Swap16IfLE(cr.srcY);
+
+			if (db) fprintf(stderr, "Copy:    %dx%d+%d+%d\n", rect.r.w, rect.r.h, rect.r.x, rect.r.y);
+			area_copyrect += rect.r.w * rect.r.h;
+
+			/* If RichCursor encoding is used, we should extend our
+			   "cursor lock area" (previously set to destination
+			   rectangle) to the source rectangle as well. */
+
+			if (db) fprintf(stderr, "FBU-SCL3  %.6f\n", dnow());
+
+			SoftCursorLockArea(cr.srcX, cr.srcY, rect.r.w, rect.r.h);
+
+			if (db) fprintf(stderr, "FBU-SCL4  %.6f\n", dnow());
+
+			if (appData.copyRectDelay != 0) {
+				XFillRectangle(dpy, desktopWin, srcGC, cr.srcX, cr.srcY, rect.r.w, rect.r.h);
+				XFillRectangle(dpy, desktopWin, dstGC, rect.r.x, rect.r.y, rect.r.w, rect.r.h);
+				XSync(dpy,False);
+				usleep(appData.copyRectDelay * 1000);
+				XFillRectangle(dpy, desktopWin, dstGC, rect.r.x, rect.r.y, rect.r.w, rect.r.h);
+				XFillRectangle(dpy, desktopWin, srcGC, cr.srcX, cr.srcY, rect.r.w, rect.r.h);
+			}
+
+			if (db) fprintf(stderr, "FBU-CPA1  %.6f\n", dnow());
+			if (!appData.useXserverBackingStore) {
+				copy_rect(rect.r.x, rect.r.y, rect.r.w, rect.r.h, cr.srcX, cr.srcY);
+				put_image(rect.r.x, rect.r.y, rect.r.x, rect.r.y, rect.r.w, rect.r.h, 0);
+				XSync(dpy, False);
+			} else {
+				XCopyArea(dpy, desktopWin, desktopWin, gc, cr.srcX, cr.srcY,
+				    rect.r.w, rect.r.h, rect.r.x, rect.r.y);
+			}
+			if (db) fprintf(stderr, "FBU-CPA2  %.6f\n", dnow());
+
+			break;
+		}
+
+		case rfbEncodingRRE:
+		{
+			switch (myFormat.bitsPerPixel) {
+			case 8:
+				if (!HandleRRE8(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 16:
+				if (!HandleRRE16(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 32:
+				if (!HandleRRE32(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			}
+			break;
+		}
+
+		case rfbEncodingCoRRE:
+		{
+			switch (myFormat.bitsPerPixel) {
+			case 8:
+				if (!HandleCoRRE8(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 16:
+				if (!HandleCoRRE16(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 32:
+				if (!HandleCoRRE32(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			}
+			break;
+		}
+
+		case rfbEncodingHextile:
+		{
+			switch (myFormat.bitsPerPixel) {
+			case 8:
+				if (!HandleHextile8(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 16:
+				if (!HandleHextile16(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 32:
+				if (!HandleHextile32(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			}
+			break;
+		}
+
+		case rfbEncodingZlib:
+		{
+			switch (myFormat.bitsPerPixel) {
+			case 8:
+				if (!HandleZlib8(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 16:
+				if (!HandleZlib16(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 32:
+				if (!HandleZlib32(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			}
+			break;
+		}
+
+		case rfbEncodingTight:
+		{
+			if (db) fprintf(stderr, "Tight:   %dx%d+%d+%d\n", rect.r.w, rect.r.h, rect.r.x, rect.r.y);
+			area_tight += rect.r.w * rect.r.h;
+			if (db) fprintf(stderr, "FBU-TGH1  %.6f\n", dnow());
+
+			switch (myFormat.bitsPerPixel) {
+			case 8:
+				if (!HandleTight8(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 16:
+				if (!HandleTight16(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 32:
+				if (!HandleTight32(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			}
+			if (db) fprintf(stderr, "FBU-TGH2  %.6f\n", dnow());
+			break;
+		}
+
+		/* runge adds zrle and zywrle: */
+		case rfbEncodingZRLE:
+#if DO_ZYWRLE
+		zywrle_level = 0;
+		case rfbEncodingZYWRLE:
+#endif
+		{
+			if (db) fprintf(stderr, "ZRLE:    %dx%d+%d+%d\n", rect.r.w, rect.r.h, rect.r.x, rect.r.y);
+			area_zrle += rect.r.w * rect.r.h;
+			switch (myFormat.bitsPerPixel) {
+			case 8:
+				if (!HandleZRLE8(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			case 16:
+				if (myFormat.greenMax > 0x1f) {
+					if (!HandleZRLE16(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+						return False;
+					}
+				} else {
+					if (!HandleZRLE15(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+						return False;
+					}
+				}
+				break;
+			case 32:
+			    {
+				unsigned int maxColor=(myFormat.redMax<<myFormat.redShift)|
+				    (myFormat.greenMax<<myFormat.greenShift)|
+				    (myFormat.blueMax<<myFormat.blueShift);
+				static int ZRLE32 = -1;
+
+				if (ZRLE32 < 0) {
+					/* for debugging or workaround e.g. BE display to LE */
+					if (getenv("ZRLE32")) {
+						if (strstr(getenv("ZRLE32"), "24Up")) {
+							ZRLE32 = 3;
+						} else if (strstr(getenv("ZRLE32"), "24Down")) {
+							ZRLE32 = 2;
+						} else {
+							ZRLE32 = 1;
+						}
+					} else {
+						ZRLE32 = 0;
+					}
+				}
+
+if (db) fprintf(stderr, "maxColor: 0x%x  mfbigEnding: %d\n", maxColor, myFormat.bigEndian);
+
+				if (ZRLE32 == 1) {
+if (db) fprintf(stderr, "HandleZRLE32\n");
+					if (!HandleZRLE32(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+						return False;
+					}
+				} else if (ZRLE32 == 2) {
+if (db) fprintf(stderr, "HandleZRLE24Down\n");
+					if (!HandleZRLE24Down(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+						return False;
+					}
+				} else if (ZRLE32 == 3) {
+if (db) fprintf(stderr, "HandleZRLE24Up\n");
+					if (!HandleZRLE24Up(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+						return False;
+					}
+				} else if ((myFormat.bigEndian && (maxColor&0xff)==0) || (!myFormat.bigEndian && (maxColor&0xff000000)==0)) {
+if (db) fprintf(stderr, "HandleZRLE24\n");
+					if (!HandleZRLE24(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+						return False;
+					}
+				} else if (!myFormat.bigEndian && (maxColor&0xff)==0) {
+if (db) fprintf(stderr, "HandleZRLE24Up\n");
+					if (!HandleZRLE24Up(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+						return False;
+					}
+				} else if (myFormat.bigEndian && (maxColor&0xff000000)==0) {
+if (db) fprintf(stderr, "HandleZRLE24Down\n");
+					if (!HandleZRLE24Down(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+						return False;
+					}
+				} else if (!HandleZRLE32(rect.r.x,rect.r.y,rect.r.w,rect.r.h)) {
+					return False;
+				}
+				break;
+			    }
+			}
+			break;
+		}
+
+		default:
+		fprintf(stderr,"Unknown rect encoding %d\n", (int)rect.encoding);
+		return False;
+		}
 
-      /* Now we may discard "soft cursor locks". */
-      SoftCursorUnlockScreen();
-    }
+		/* Now we may discard "soft cursor locks". */
+		if (db) fprintf(stderr, "FBU-SUL1  %.6f\n", dnow());
+
+		SoftCursorUnlockScreen();
+
+		if (db) fprintf(stderr, "FBU-SUL2  %.6f\n", dnow());
+	}
+
+	if (try_delay_sync) {
+		skip_maybe_sync = 0;
+	}
+
+	if (1 || area_copyrect) {
+		/* we always do this now for some reason... */
+		if (db) fprintf(stderr, "FBU-XSN1  %.6f\n", dnow());
+		XSync(dpy, False);
+		if (db) fprintf(stderr, "FBU-XSN2  %.6f\n", dnow());
+	}
+	sent_FBU = 0;
+	/*
+	 * we need to be careful since Xt events are processed
+	 * usually in the middle of FBU.  So we do any scheduled ones now
+	 * which is pretty safe but not absolutely safe.
+         */
+	if (do_format_change) {
+		cutover_format_change();
+		do_format_change = 0;
+		SetVisualAndCmap();
+		SetFormatAndEncodings();
+		if (do_cursor_change) {
+			if (do_cursor_change == 1) {
+				DesktopCursorOff();
+			}
+			do_cursor_change = 0;
+		} else {
+			SendFramebufferUpdateRequest(0, 0, si.framebufferWidth,
+			    si.framebufferHeight, False);
+			skip_incFBU = 1;
+		}
+	}
+	if (do_fb_update != 0.0) {
+		if (dnow() > do_fb_update + 1.1) {
+			do_fb_update = 0.0;
+			SendFramebufferUpdateRequest(0, 0, si.framebufferWidth,
+			    si.framebufferHeight, False);
+		}
+	}
 
 #ifdef MITSHM
     /* if using shared memory PutImage, make sure that the X server has
